#
#  @file   CallStack.py
#  @author Francis Moreau
#  date    Wed Apr 23 2008
#  
#  Description:
#
#  Type your description here
#
#  Copyright (C) 2008 Paraxip Technologies.
#  All Rights Reserved.
#

import sys, traceback, inspect
from paraxip.infra.PyLoggingFunctions import *

def whoAmI():
  return sys._getframe(1).f_code.co_name

def whoCalled():
  return sys._getframe(2).f_code.co_name

def getCallerInfo():
  f = sys._getframe(2)       

  strMethodName = f.f_code.co_name
  strFileName = f.f_code.co_filename

  argClass = None
  args = inspect.getargvalues(f)
  if (len(args[0]) > 0):
    argName = args[0][0] # potentially the 'self' arg if its a method
    argClass = type(args[3][argName])
  return (strMethodName, strFileName, argClass)

def getCallStack():
  strOneLine = ""

  listLines = traceback.format_stack() # Get the Call Stack
  if ((listLines is None) or (len(listLines) < 1)):
    return strOneLine

  for strLine in listLines:
    strOneLine = strOneLine + strLine
  return strOneLine

def logCallStack(in_Logger, in_LogLevel):
  if (not in_Logger.isEnabledFor(in_LogLevel)):
    return

  listLines = traceback.format_stack() # Get the Call Stack
  if ((listLines is None) or (len(listLines) < 1)):
    return

  strOneLine = "Call Stack:\n"
  for strLine in listLines:
    strOneLine = strOneLine + strLine
  log(in_Logger, in_LogLevel, strOneLine)

## !!MIRROR FILE, DO NOT MODIFY!!
