<?xml version="1.0" encoding="utf-8"?>

<!--

This stylesheet convert a oamWebServer.properties from a gateway version of 4.1.2 to
version 4.1.3. To do so:

Set the following parameters,

netborder.oamWebServer.gwVersion=4.1.3
-->

<xsl:stylesheet version="1.0"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method = "xml" indent = "yes" /> 

<!-- This template copy all the elements and their attributes -->
<xsl:template match="node()|@*">
  <xsl:copy>
    <xsl:apply-templates select="node()|@*"/>
  </xsl:copy>
</xsl:template>

<!-- TEMPORARY FIX - Setting version to 4.1.4 for preliminary release to -->
<!-- partners. Permanent fix will be done with bug 6653.-->
<!-- Set netborder.oamWebServer.gwVersion=4.1.3 -->
<xsl:template match="netborder/oamWebServer">
  <xsl:variable name="count" select="count(descendant-or-self::gwVersion)"/>
  <xsl:copy>   
    <xsl:apply-templates select="@*"/>
    <xsl:if test="$count = 0">
      <xsl:element name="gwVersion">
        <xsl:attribute name="value">4.1.3</xsl:attribute>
        <xsl:attribute name="defined">true</xsl:attribute>
      </xsl:element>
    </xsl:if>
    <xsl:apply-templates/>
  </xsl:copy>
</xsl:template>

<xsl:template match="netborder/oamWebServer/gwVersion">
  <xsl:copy>   
    <xsl:attribute name="value">4.1.3</xsl:attribute>
    <xsl:attribute name="defined">true</xsl:attribute>
    <xsl:apply-templates/>
  </xsl:copy>
</xsl:template>

</xsl:stylesheet> 

