<?xml version="1.0" encoding="utf-8"?>

<!--

This stylesheet convert a pstn-config from a gateway version of 3.0.0 to version
3.0.1. To do so:

-If LevelControl attribute mode=DISABLED
  Attributes gainIndB and targetLevelIndBM0 must be removed.

-If LevelControl attribute mode=MANUAL
  targetLevelIndBM0 must be removed.

-If LevelControl attribute mode=AUTOMATIC
  gainIndB must be removed

-->

<xsl:stylesheet version="1.0"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method = "xml" indent = "yes" /> 

<!-- This template copy all the elements and their attributes -->
<xsl:template match="node()|@*">
  <xsl:copy>
    <xsl:apply-templates select="node()|@*"/>
  </xsl:copy>
</xsl:template>


<!-- 
If the following templates match they prevent the attribute from being copied.
-->
<xsl:template match="LevelControl[@mode='AUTOMATIC']/@gainIndB">
</xsl:template>

<xsl:template match="LevelControl[@mode='MANUAL']/@targetLevelIndBM0">
</xsl:template>

<xsl:template match="LevelControl[@mode='DISABLED']/@gainIndB">
</xsl:template>

<xsl:template match="LevelControl[@mode='DISABLED']/@targetLevelIndBM0">
</xsl:template>

</xsl:stylesheet> 
