#!/bin/sh
#
# This script install the Sangoma drivers for the netborder-gateway
#

#first Make sure that the wanpipe rpm package is not installed 
#on the target system
kernel_version=$(uname -r)
rpm -qa | grep wanpipe-$kernel_version &> /dev/null
if [[ "$?" == 0 ]] ; then
   echo -e "INFO: Sangoma driver package wanpipe-$kernel_version is already installed on the system. Uninstall this rpm package first and then re-run the script:\n\"XXX_INSTDIR_XXX/linux/install-drivers.sh\"\nto complete Sangoma driver installation."
   exit 0
fi

# Install Sangoma drivers
pushd XXX_INSTDIR_XXX/drivers/wanpipe
./Setup install --protocol=AFT_TE1 --silent
popd

# Pre-configure writes only if hardware is already installed
/usr/sbin/wanrouter hwprobe 2> /dev/null
if [[ "$?" != 0 ]] ; then
  echo -e "INFO: No Sangoma cards found.\nPlease insert Sangoma cards into the system and re-run the script:\n\"XXX_INSTDIR_XXX/linux/install-drivers.sh\"\nto complete Sangoma driver installation."  
  exit 0
fi

