//-----------------------------------------------
// Audio form
//-----------------------------------------------
Ext.namespace("Paraxip.wizard");

var labelWidth = 285;

var audio_form = new Ext.Panel({
  title           : "Audio Quality Configuration"
  ,layout         : 'form'
  ,autoWidth      : true
  ,autoHeigth     : true
  ,autoScroll     : true
  ,frame          : true
  ,header         : false
  ,id             : "Paraxip.wizard.audio_form"
  ,labelWidth     : labelWidth
  ,bodyStyle      : "text-align:left;padding-left:15px;"
  ,defaults       : {
    anchor: '65%'
  }
  ,listeners  : { 
    'show':function( form ) {
      refreshDisabledStates()     
    }
  }
  ,items: [{}]
});

var AudioQualityDescriptionLabel = new Ext.form.Label({
   id      : "Paraxip.wizard.AudioQualityDescriptionLabel"
  ,text   : "Set your audio quality parameters"
  ,helpText : "HardwareLevelControlLevelControl"
  ,style  : 'font-size:120%;font-weight:bold; line-height:60px;'
});

Paraxip.wizard.AgcMode = new Ext.form.ComboBox({
  id              : 'agcMode'
  ,fieldLabel     : "Mode"
  ,name           : "agcMode"
  ,store          : ['DISABLED', 'MANUAL', 'AUTOMATIC' ]
  ,helpText       : "HardwareLevelControlLevelControlmode"
  ,forceSelection : true
  ,triggerAction  : 'all'
  ,mode           : 'local'
  ,typeAhead      : true
  ,value          : 'DISABLED'
  ,width          : 100
  ,listWidth      : 272
  ,selectOnFocus  : true
  ,readOnly       : true
  ,anchor         : '40%'
  ,listeners  : { 
    'select':function( combo, record, index ) {
      refreshDisabledStates()     
    }
  }
});

var refreshDisabledStates = function() {
  if (Paraxip.wizard.AgcMode.value == 'DISABLED') {
    Paraxip.wizard.AgcDirection.setDisabled(true);
    Paraxip.wizard.AgcAutoTargetLevel.setDisabled(true);
    Paraxip.wizard.AgcManualGain.setDisabled(true);
  }
  else if (Paraxip.wizard.AgcMode.value == 'AUTOMATIC') {
    Paraxip.wizard.AgcDirection.setDisabled(false);
    Paraxip.wizard.AgcAutoTargetLevel.setDisabled(false);
    Paraxip.wizard.AgcManualGain.setDisabled(true);
  }
  else if (Paraxip.wizard.AgcMode.value == 'MANUAL') {
    Paraxip.wizard.AgcDirection.setDisabled(false);
    Paraxip.wizard.AgcAutoTargetLevel.setDisabled(true);
    Paraxip.wizard.AgcManualGain.setDisabled(false);
  } 
};

Paraxip.wizard.AgcDirection = new Ext.form.ComboBox({
  id              : 'agcDirection'
  ,name           : "agcDirection"
  ,fieldLabel     : "Direction"
  ,store          : ['TO_PSTN', 'FROM_PSTN', 'ALL' ]
  ,forceSelection : true
  ,helpText       : "HardwareLevelControlLevelControldirection"
  ,disabled       : true
  ,triggerAction  : 'all'
  ,mode           : 'local'
  ,typeAhead      : true
  ,value          : 'ALL'
  ,width          : 100
  ,listWidth      : 272
  ,selectOnFocus  : true
  ,readOnly       : true
  ,anchor         : '30%'
});

Paraxip.wizard.ManualGainIsValid = true
var validateManualGain = function(field)
{
  value = field.getValue()
  if ( value < -24 || value > 24 ) {
    field.markInvalid(
      "Manual Gain must be within -24 dB and 24 dB");
      Paraxip.wizard.ManualGainIsValid = false
  } else {
    field.clearInvalid();
    Paraxip.wizard.ManualGainIsValid = true
  }
}

Paraxip.wizard.AutoLevelIsValid = true
var validateAutoLevel = function(field)
{
  value = field.getValue()
  if ( value < -40 || value > 0 ) {
    field.markInvalid(
      "Automatic target level must be within -40 dBm0 and 0 dBm0");
      Paraxip.wizard.AutoLevelIsValid = false
  } else {
    field.clearInvalid();
    Paraxip.wizard.AutoLevelIsValid = true
  }
}

Paraxip.wizard.AgcAutoTargetLevel = new Ext.form.TextField({
   id         : 'Paraxip.wizard.AgcAutoTargetLevel'
  ,fieldLabel : "Automatic Target level (dBM0)"
  ,name       : "agcAutoTargetLevel"
  ,helpText    : "HardwareLevelControlLevelControltargetLevelIndBM0"
  ,disabled   : true  
  ,value      : '0'
  ,maskRe     : /[\-0-9]/
  ,listeners  : {
    'blur': validateAutoLevel
  }
});

Paraxip.wizard.AgcManualGain = new Ext.form.TextField({
   id         : 'Paraxip.wizard.AgcManualGain'
  ,fieldLabel : "Manual Gain (dB)"  
  ,name       : "agcManualGain"
  ,helpText   : "HardwareLevelControlLevelControlgainIndB"
  ,disabled   : true  
  ,value      : '0'
  ,maskRe     : /[\-0-9]/
  ,listeners  : {
    'blur': validateManualGain
  }
});

Paraxip.wizard.AgcSet =  new Ext.form.FieldSet({
  id              : "Paraxip.wizard.AgcSet"
  ,name           : "AgcSet"
  ,title          : 'Level Control'
  ,autoHeight     : true
  ,collapsed      : false
  ,defaults       : {anchor: '-20'}
  ,helpText : "HardwareLevelControlLevelControl"
  ,items          : [
     Paraxip.wizard.AgcMode
    ,Paraxip.wizard.AgcDirection
    ,Paraxip.wizard.AgcAutoTargetLevel
    ,Paraxip.wizard.AgcManualGain
  ]
});

audio_form.add(AudioQualityDescriptionLabel);
audio_form.add(Paraxip.wizard.AgcSet);
