Ext.namespace("Paraxip.wizard");

if( defaultUDPPort == undefined ) {
  var defaultUDPPort = $defaultUDPPort;
}
if( defaultTCPPort == undefined ) {
  var defaultTCPPort = $defaultTCPPort;
}
if( defaultTLSPort == undefined ) {
  var defaultTLSPort = $defaultTLSPort;
}
if( defaultUDPTCPSendPort == undefined ) {
  var defaultUDPTCPSendPort = $defaultUDPTCPSendPort;
}
if( defaultTLSSendPort == undefined ) {
  var defaultTLSSendPort = $defaultTLSSendPort;
}
if( defaultPrimarySipServer == undefined ) {
  var defaultPrimarySipServer = "$defaultPrimarySipServer";
}
if( startGwTimeout == undefined ) {
  var startGwTimeout = $startGwTimeout;
}

var hasFxoInterface = false;

Paraxip.wizard.oem = undefined;
Paraxip.wizard.preInitializedBoard = undefined;

var oemTestLabel = new Ext.form.Label({
  id    : "Paraxip.wizard.oemTestLabel"
  ,text : ""
});

Ext.Ajax.request({
  url: Paraxip.baseUrl + "getGCParameterValue",
  disableCaching: true,
  params: {"paramName":'netborder.oamWebServer.oem'},
  success: function(result){
    var response = Ext.util.JSON.decode(result.responseText);
    if( response.paramValue != undefined && response.paramValue != "") {
      Paraxip.wizard.oem = response.paramValue;
      if( Paraxip.wizard.oem == "test" ) {
        oemTestLabel.setText("This is a OEM test");
      }
    }
  }
});

function postScriptHandler(response) {
  Paraxip.hideProgressBar();
  next_button.enable();
  result = Ext.util.JSON.decode(response.responseText);

  results.setValue(result.scriptResult);

  var lay = wizard.getLayout();
  lay.setActiveItem("Paraxip.wizard.script_results");
  lay.container.setTitle(lay.activeItem.title);
};

function beforeSubmit() {
  var records =
  hardware_form.findById('Paraxip.wizard.board_display').getStore().getRange();

  return records;
};

/**
 * @param hasFxo: true if pstn-config contains at least one FXO interface
 * @param executeScript: true if a script must be executed or false if not
 */
function afterSubmit(hasFxo,executeScript) {
  // Paraxip.console.debug('Done submitting configuration');
  hardware_form.findById('Paraxip.wizard.board_display').getStore().removeAll();

  var mainTab = Ext.getCmp('mainTabPanel');
  if(mainTab != undefined) {
    Paraxip.isConfigOutOfSynch(true);
    var editorTab = mainTab.findById("pstnEditorTabId");
    editorTab.setDisabled(false);
    
    //get the treePanel
    if (editorTab.rendered) {
      reloadTree(false);
    }
    Paraxip.mainTabPanel.configFileExists = true;
    
    Paraxip.config.fxoTune.update();
  }
  
  // Rembember if FXO interfaces are presents in the Gateway.
  hasFxoInterface = hasFxo;

  if( hardwareDetectionMode ) {
    Paraxip.wizard.availableInterfacesGrid.getStore().removeAll();
    Paraxip.wizard.interfacesStoreMap.clear();
  }

  if( executeScript ) {
    back_button.setVisible(false);
    next_button.setVisible(true);
    next_button.disable();
    save_button.setVisible(false);

    var lay = wizard.getLayout();
    lay.setActiveItem("Paraxip.wizard.waiting_script");
    lay.container.setTitle(lay.activeItem.title);

    Paraxip.showProgressBar("Executing post quick setup script...");

    // Wait 2 seconds before executing the script in case the script is very
    // short and will return right away. The user will be a bit confused about
    // what just happened if he sees a fast transition without having the time
    // to read the information.
    setTimeout( function(){
      Ext.Ajax.request({
        url       : Paraxip.baseUrl + "wizard/executePostQuickSetupCmd"
        ,method   : "POST"
        ,params   : {'js':''}
        ,timeout  : 300000 // 5 minutes timeout
        ,success  : postScriptHandler
        ,failure  : function() {
          wizard.getLayout().setActiveItem("Paraxip.wizard.script_results");
          next_button.enable();
          Paraxip.hideProgressBar();
          Paraxip.failureMessage();
        }
      });
    }, 1000 );

    return;
  }

  Paraxip.isConfigOutOfSynch(true);

  navHandler('next');

};

function showRestartGwMsg() {
  if( !isGatewayInCLI ) {
    Ext.Msg.confirm(
      "New Configuration Not Applied", "The new configuration created by the "+
      "Quick Setup will be effective on next gateway startup. Do you want to "+
      "start the gateway now?", restartGatewayHandler);
  }
}



/*
 * Load hardware_form fields values from dictionnary 'board'
 */
function initializeBoardFormValues( board ){
  // Just store data for now. It needs to be processed only once 
  // the hardware autodetection is completed and available boards grid is
  // populated
  Paraxip.wizard.preInitializedBoard = board
  
  //if( board[0].active ) {
    //Paraxip.wizard.availableBoardsGrid.getSelectionModel().selectRow( 0, true )
  //}
  // Default is supported

};    


/*
 * Load sip_form fields values from dictionnary 'sip'
 */
function initializeSipFormValues( sip ){
  Paraxip.wizard.udpPort.setValue( sip.udpListenPort )
  Paraxip.wizard.udpPort.setDisabled( !sip.udpEnabled )
  Paraxip.wizard.enableUdp.setValue( sip.udpEnabled )
  Paraxip.wizard.tcpPort.setValue( sip.tcpListenPort )
  Paraxip.wizard.tcpPort.setDisabled( !sip.tcpEnabled )
  Paraxip.wizard.enableTcp.setValue( sip.tcpEnabled )
  Paraxip.wizard.tlsPort.setValue( sip.tlsListenPort )
  Paraxip.wizard.tlsPort.setDisabled( !sip.tlsEnabled )
  Paraxip.wizard.enableTls.setValue( sip.tlsEnabled )
  if( sip.encryption == "never" ) {
    Paraxip.wizard.srtpMode.setValue( 'Do not support encryption' )
  } else if ( sip.encryption == "always" ) {
    Paraxip.wizard.srtpMode.setValue( 'Require Encryption' )
  }
  // Default is supported

};    

/*
 * Load audio_form fields values from dictionnary 'isdnValues'
 */
function initializeAudioFormValues( audioValues ){
  Paraxip.wizard.AgcMode.setValue( audioValues.mode )
  Paraxip.wizard.AgcDirection.setValue( audioValues.direction )
  Paraxip.wizard.AgcAutoTargetLevel.setValue( audioValues.autoTargetLevel )
  Paraxip.wizard.AgcManualGain.setValue( audioValues.manualGain )
}
  
/*
 * Load isdn_form fields values from dictionnary 'isdnValues'
 */
function initializeIsdnFormValues( isdnValues ){
  Paraxip.wizard.radio_t1.setValue( isdnValues.type )
  if( isdnValues.type == "T1" ) {
    Paraxip.wizard.esf.setValue( isdnValues.framing )
    Paraxip.wizard.b8zs.setValue( isdnValues.encoding )
    Paraxip.wizard.ess.setValue( isdnValues.switchVariant )
    
  } else if( isdnValues.type == "E1" ) {
  
    Paraxip.wizard.crc4.setValue( isdnValues.framing )
    Paraxip.wizard.hdb3.setValue( isdnValues.encoding )
    Paraxip.wizard.e1CCS.setValue( isdnValues.signaling )
    
    if( isdnValues.signaling == "CCS" ) {
      Paraxip.wizard.etsi.setValue( isdnValues.switchVariant )
    } else {
      Paraxip.wizard.countryR2.setValue( isdnValues.countryR2 )
    }
    
  } else {
    Paraxip.wizard.j1_esf.setValue( isdnValues.framing )
    Paraxip.wizard.j1_b8zs.setValue( isdnValues.encoding )
    Paraxip.wizard.INS1500.setValue( isdnValues.switchVariant )
  }
  
};   

/*
 * Load call_routing_form fields values from dictionnary 'routing'
 */
function initializeRoutingFormValues( routing ){
  Paraxip.wizard.outTransportProtocol.setValue( routing.transport )
  Paraxip.wizard.sipOutAddress.setValue( routing.primarySipServerIp )

  defaultUDPTCPSendPort = routing.primarySipServerUdpTcpPort
  defaultTLSSendPort = routing.primarySipServerTlsPort
  
  if( routing.transport == 'udp' || routing.transport == 'tcp') {
    Paraxip.wizard.sipOutPort.setValue( routing.primarySipServerUdpTcpPort )
  } else {
    // tls
    Paraxip.wizard.sipOutPort.setValue( routing.primarySipServerTlsPort )
  }
  
  if( routing.failoverEnabled ) {
    Paraxip.wizard.enableFailover.expand( )
  } else {
    Paraxip.wizard.enableFailover.collapse( )
  }
  Paraxip.wizard.failoverSipOutAddress.setValue( routing.failoverBackupSipServerIp )
  if( routing.transport == 'udp' || routing.transport == 'tcp') {
    Paraxip.wizard.failoverSipOutPort.setValue( routing.failoverBackupSipServerUdpTcpPort )
  } else {
    Paraxip.wizard.failoverSipOutPort.setValue( routing.failoverBackupSipServerTlsPort )
  }
  Paraxip.wizard.failoverSipTimeout.setValue( routing.failoverTimeout )
  
  Paraxip.wizard.outboundMask.setValue( routing.outNumberMask )
  Paraxip.wizard.outboundPrefix.setValue( routing.outNumberPrefix )
  Paraxip.wizard.countryCode.setValue( routing.countryCode )
  
};   


function getInitialValues(){
   Ext.Ajax.request({
      url: Paraxip.baseUrl + "wizard/getInitialValues"
      ,method: 'POST'
      ,disableCaching: true
      ,params: {'js':''}
      ,timeout: 30000
      ,success: function(result){
        response = Ext.util.JSON.decode(result.responseText);
        if( response.success ) {
          var boardValues = response.data.board
          initializeBoardFormValues( boardValues )
        
          var countryValues = response.data.country
          Paraxip.wizard.country.setValue( countryValues.country )
          
          var isdnValues = response.data.isdn
          initializeIsdnFormValues( isdnValues )
          
          var audioValues = response.data.audio
          initializeAudioFormValues( audioValues )
          
          var sip = response.data.sip
          initializeSipFormValues( sip )
          
          var routing = response.data.routing
          initializeRoutingFormValues( routing )
          
          var service = response.data.service
          Paraxip.wizard.autoStartGW.setValue(service.autoStartGW)
          Paraxip.status.controls.autoStartGW.setValue(service.autoStartGW)
          Paraxip.wizard.failureAutoStartGW.setValue(service.autoStartGWOnFailure)
          Paraxip.status.controls.failureAutoStartGW.setValue(service.autoStartGWOnFailure)
          
     
          

          //finishHandler(true);
        } else {
          //finishHandler(false);
        }
      }
      ,failure: function(){
        Paraxip.failureMessage();
      }
    }); 
}

/*
 * Calls the restartGateway method of the status controller in the backend
 * if the user chose yes after the quick setup.
 * @param choice: yes if the user clicked on yes in the confirm message;
 *                no if the user clicked on no.
 */
function restartGatewayHandler(choice){
  if( choice == "yes" ) {
    Paraxip.changeGwStatusBar(Paraxip.serviceStartingStatus, true, true);
    Paraxip.showProgressBar("Restarting the gateway...");
    Paraxip.gatewayStarted = false;
    Paraxip.disableItems(true);
    Ext.Ajax.request({
      url: Paraxip.baseUrl + "status/restartGateway"
      ,method: 'POST'
      ,disableCaching: true
      ,params: {js:Ext.util.JSON.encode('dummy param')}
      ,timeout: startGwTimeout
      ,success: function(result){
        response = Ext.util.JSON.decode(result.responseText);
        if( response.success ) {
          Paraxip.serviceStarted = true;
          Paraxip.changeGwStatusBar(
            Paraxip.initializingApplicationStatus, true, true);
          Paraxip.updateProgressBarText(
            "Service started. Initializing Gateway Application...");
          var task = Ext.TaskMgr.start(Paraxip.status.controls.pingGwTask);
          finishHandler(true);
        } else {
          Paraxip.isConfigOutOfSynch(true);
          afterRestart("Unable to start the gateway","The gateway failed " +
                       "to start. Please be sure there is a valid " +
                       "configuration file before launching the gateway. " +
                       "This can be accomplished by running the Quick Setup.");
          Paraxip.changeGwStatusBar(Paraxip.downStatus, false, true);
          finishHandler(false);
        }
      }
      ,failure: function(){
        Paraxip.isConfigOutOfSynch(true);
        afterRestart();
        Paraxip.failureMessage();
      }
    });
  } else {
    Paraxip.isConfigOutOfSynch(true);
  }
};

/*
 * Hide the progress bar, force a check on the gateway status to update
 * the start/stop buttons and the status bar. Can take the title and the
 * message to show the user in a pop-up window. If the message is null,
 * we show nothing.
 * @param title: the title of the window to display.
 * @param msg: the message text; null if no window should be shown.
 */
function afterRestart(title, msg){
  Paraxip.hideProgressBar();
  Paraxip.isGwStartedCall();
  if( msg != null) {
    Ext.Msg.alert(title,msg);
  }
};

var validateRecords = function () {

  if( hardwareDetectionMode ) {

    // Verify at least one interface is selected.
    if(Paraxip.wizard.availableBoardsGrid.getSelectionModel().getCount() == 0){
      Ext.Msg.alert("No Board",
                      "Please add a board to continue");
      return false;
    }

    var keySet = Paraxip.wizard.interfacesStoreMap.keySet();
    var i = 0;
    for( i; i < Paraxip.wizard.interfacesStoreMap.size(); ++i ) {

      if( keySet[i] == undefined ||
          boardActive(Paraxip.wizard.availableBoardsGrid,
                      keySet[i]) == false)
      {
        continue;
      }

      records = Paraxip.wizard.interfacesStoreMap.get(keySet[i]);
      var recordsActive = false;

      for( var j = 0; j < records.length; ++j ) {
        if( !isRecordValid(records[j]) ) {
          return false;
        }

        if (records[j].data.active) {
          recordsActive = true;
        }
      }

      if (!recordsActive) {
        Ext.Msg.alert(
          "Interface selection",
          "At least one interface must be selected on board with ID "
           + keySet[i]
        );
        return false;
      }

      if( !Paraxip.validatePhoneNumbers(records) ) {
        return false;
      }
    }
  }
  return true;
}

/*
 * Called when the user has finished the quick setup. This method posts
 * the values chosen by the user to the backend server.
 */
function saveHandler() {

  // This must ne done as the call routing form may be last when the GW is
  // in CLI so it might be possible that it is the last and the user presses
  // next.
  if (isGatewayInCLI && !validateCallRoutingFields()) {
    return;
  }

  var form = wizard.getForm();
  var el = form.getEl();

  el.dom.action = Paraxip.baseUrl + "wizard/save";
  el.dom.method = 'POST';
  var records = beforeSubmit();

  // Text fields must be enabled in order to access them from python backend.
  var udpPortEnabled = Paraxip.wizard.udpPort.disabled;
  Paraxip.wizard.udpPort.setDisabled(false);

  var tcpPortEnabled = Paraxip.wizard.tcpPort.disabled;
  Paraxip.wizard.tcpPort.setDisabled(false);

  var tlsPortEnabled = Paraxip.wizard.tlsPort.disabled;
  Paraxip.wizard.tlsPort.setDisabled(false);
  
  var agcDirectionEnabled = Paraxip.wizard.AgcDirection.disabled;
  Paraxip.wizard.AgcDirection.setDisabled(false);
  var agcAutoEnabled = Paraxip.wizard.AgcAutoTargetLevel.disabled;
  Paraxip.wizard.AgcAutoTargetLevel.setDisabled(false);
  var agcManualEnabled = Paraxip.wizard.AgcManualGain.disabled;
  Paraxip.wizard.AgcManualGain.setDisabled(false);

  var physicalConfig = Ext.util.JSON.encode(form.getValues(false)) ;

  // Enable/Disable the fields as they were.
  Paraxip.wizard.udpPort.setDisabled(udpPortEnabled);
  Paraxip.wizard.tcpPort.setDisabled(tcpPortEnabled);
  Paraxip.wizard.tlsPort.setDisabled(tlsPortEnabled);
  
  Paraxip.wizard.AgcDirection.setDisabled(agcDirectionEnabled);
  Paraxip.wizard.AgcAutoTargetLevel.setDisabled(agcAutoEnabled);
  Paraxip.wizard.AgcManualGain.setDisabled(agcManualEnabled);

  Paraxip.status.controls.autoStartGW.setValue(
    Paraxip.wizard.autoStartGW.getValue()
  );

  Paraxip.status.controls.failureAutoStartGW.setValue(
    Paraxip.wizard.failureAutoStartGW.getValue()
  );

  // Get the boards information from the hardware grid
  var boardConfigs = new Array();
  for (var i = 0; i < records.length; i++) {
    if( hardwareDetectionMode ) {
      if( Paraxip.wizard.interfacesStoreMap.get(records[i].data.id) == null ) {
        continue;
      }
    }

    boardConfigs.push(records[i].data);
  }
  boardConfigs = Ext.util.JSON.encode(boardConfigs);

  var interfacesData = new Array();

  // When using hardware detection, also send the interfaces data
  if( hardwareDetectionMode ) {
    // Be sure that the latest modifications made to the boards are in the
    // interfaces map
    if( wizardInterfacesStore.length > 0 ) {
      Paraxip.config.boards.interfacesStoreMap.put(
        wizardInterfacesStore.lastOptions.boardID
        ,wizardInterfacesStore
      );
    }
    var keySet = Paraxip.wizard.interfacesStoreMap.keySet();
    var i = 0;
    for( i; i < Paraxip.wizard.interfacesStoreMap.size(); ++i ) {
      if( keySet[i] == undefined  ||
          boardActive(Paraxip.wizard.availableBoardsGrid,
                      keySet[i]) == false)
      {
        continue;
      }
      records = Paraxip.wizard.interfacesStoreMap.get(keySet[i]);
      var recordsData = [];

      for( var j = 0; j < records.length; ++j ) {
        if( !isRecordValid(records[j]) ) {
          return false;
        }
        
        if (typeof records[j].data['phoneNumber'] == "string") {
          var phoneNumerAsInt = parseInt( records[j].data['phoneNumber'] )
          records[j].data['phoneNumber'] = phoneNumerAsInt
        }
        
        recordsData.push(records[j].data);
      }
      interfacesData.push({
        "boardID":keySet[i]
        ,"interfacesData":recordsData
      });
    }
    interfacesData = Ext.util.JSON.encode(interfacesData);
  }
  
  Ext.Ajax.request({
    url: Paraxip.baseUrl + "wizard/save"
    ,method: 'POST'
    ,disableCaching: true
    ,params:{
      'boardConfigs'    : boardConfigs
      ,'interfacesData' : interfacesData
      ,'physicalConfig' : physicalConfig
    }
    ,success: function(result){
      response = Ext.util.JSON.decode(result.responseText);
      afterSubmit(response.hasFxo, response.executeScript);
    }
    ,failure: Paraxip.failureMessage
  });

};

/**
 * Handler for the Finish button after the Post Quick Setup script has been
 * executed and the user wants to continue
 */
function finishHandler(pingGw) {
  navHandler("next");
  finish_button.setVisible(false);
  start_button.setVisible(false);
  fxotune_button.setVisible(false);

  var mainTab = Ext.getCmp('mainTabPanel');

  // We check that mainTabPanel is defined to see if the Quick Setup was
  // executed with the WebUI in its complete form or using the lightbox URL
  // http://127.0.0.1:7783/wizard/lightbox_quick_setup/. If the WebUI is in its
  // complete form, we go to the Status & Controls tab. Otherwise, we go to the
  // Finish form of the Quick Setup.
  if( mainTab != undefined ) {
    mainTab.setActiveTab("statusControlTabId");
   
  } else {
    // since we are in a lightbox, redirect to Status & Controls using
    // window.location
    window.location = 
      Paraxip.baseUrl + "status/lightbox_controls?pingGW=" + pingGw;
  }
}

function helpHandler() {
  helpWindow.setTitle("Boards and Interfaces Help");
  helpWindow.show();
  helpTextArea.body.load( {
    url: "/static/help/quick-setup/qs-boards.html"
  });
}

function fxotuneHandler() {

  navHandler("next");
  finish_button.setVisible(false);
  start_button.setVisible(false);
  fxotune_button.setVisible(false);
  
  var mainTab = Ext.getCmp('mainTabPanel');

  // We check that mainTabPanel is defined to see if the Quick Setup was
  // executed with the WebUI in its complete form or using the lightbox URL
  // http://127.0.0.1:7783/wizard/lightbox_quick_setup/. If the WebUI is in its
  // complete form, we go to the Status & Controls tab. Otherwise, we go to the
  // Finish form of the Quick Setup.
  if( mainTab != undefined ) {

    var configTab = Ext.getCmp("Paraxip.config.configTabPanel");
    configTab.setActiveTab("fxoTuneTabId");

    // Go to FXO Calibration wizard
    mainTab.setActiveTab("configTabId");

  } else {
    // since we are in a lightbox, redirect to Status & Controls using
    // window.location
    window.location = Paraxip.baseUrl + "fxoTune/lightbox_fxotune";
  }
}

function SipOutAddress(sipOutAddressOld)
{
  this.sipOutAddressOld = sipOutAddressOld;

  this.validateOutAddress = function(field)
  {
    // This function ensures that the validation is done only once per
    // different field value.
    var bReturn = true;
    if (!isValidHostName(field.getValue()) &&
        field.getValue() != sipOutAddressOld) {
      Ext.Msg.alert("Invalid Hostname",
                    field.getValue() +
                    " is not a valid sip server addresses. " +
                    "Please enter an IPv4 address or a fully qualified " +
                    "domain name (FQDN).");
      sipOutAddressOld = field.getValue();
      bReturn = false;
    }
    return bReturn;
  }
}
var sipOutAddressOld = new SipOutAddress("");
var failoverSipOutAddress = new SipOutAddress("");

var validateCallRoutingFields = function()
{
  var bReturn = true;
  if ( Paraxip.wizard.enableFailover.collapsed == false ) {
    if (Paraxip.wizard.failoverSipOutAddress.getValue() == "" ||
        Paraxip.wizard.failoverSipOutPort.getValue() == "" ||
        Paraxip.wizard.failoverSipTimeout.getValue() == "") {
      Ext.Msg.alert('No Failover Server',
                    "Please enter the Backup server address, port, and " +
                    "timeout or disable the failover feature to continue.");
      bReturn = false;
    } else {
      bReturn =
        failoverSipOutAddress.validateOutAddress(
          Paraxip.wizard.failoverSipOutAddress
        );
    }
  } else if (Paraxip.wizard.sipOutAddress.getValue() == "" ||
             Paraxip.wizard.sipOutPort.getValue() == "") {
    Ext.Msg.alert('No Primary Server',
                  "Please enter the Primary server address and port to " +
                  "continue.");
    bReturn = false;
  } else {
    bReturn =
      sipOutAddressOld.validateOutAddress(Paraxip.wizard.sipOutAddress);
  }

  return bReturn;
}

var updateDefaultPort = function(numberField)
{
  // Change the value to TLS if TLS is enabled and only if the user did not
  // already changed the port.
  if (Paraxip.wizard.enableTls.checked) {
    if (numberField.getValue() == "" ||
        numberField.getValue() == defaultUDPTCPSendPort) {
      numberField.setValue(defaultTLSSendPort);
    }
  } else {
    if (numberField.getValue() == "" ||
        numberField.getValue() == defaultTLSSendPort) {
      numberField.setValue(defaultUDPTCPSendPort);
    }
  }
}



/**
 *
 * This method determines wich form to show to the user in the wizard
 * depending on the direction and the types of boards in the grid.
 * @param direction: helps to know wich form to show; ('next' or 'back')
 *
 */
var navHandler = function(direction) {
  var lay = wizard.getLayout();

  var active_id = lay.activeItem.id;

  var active_item;

  var show_back = true;
  var boardGrid = Ext.getCmp('Paraxip.wizard.board_display');
  var hasAnalog = Paraxip.gridHasAnalogBoard(boardGrid);
  


  if( hardwareDetectionMode ) {
    var hasDigital = Paraxip.hwDetectionGridHasDigitalBoard(boardGrid);
    var hasPRI = Paraxip.hwDetectionGridHasPRIBoard(boardGrid);
  } else {
    var hasDigital = Paraxip.gridHasDigitalBoard(boardGrid);
    var hasPRI = Paraxip.gridHasPRIBoard(boardGrid);
  }
  
  var hasVirtualDigital = Paraxip.gridHasVirtualDigitalBoard(boardGrid);

  //Determine witch form to render_next
  if (direction == "next") { //Go forward
    switch (active_id) {
    case "Paraxip.wizard.front_form":
      getInitialValues()
      if( hardwareDetectionMode ) {
        Paraxip.wizard.interfacesStoreMap.clear();
        wizardInterfacesStore.removeAll();
        boardGrid.getStore().load({
          params:{js:"js_str"}
        });
      }
      active_item = "Paraxip.wizard.hardware_form";
      show_back = false;
      break;
    case "Paraxip.wizard.hardware_form":
      if (!hardwareDetectionMode || validateRecords()) {
        if (hasAnalog || hasDigital) {
          active_item = "Paraxip.wizard.analog_form";
        } else if (hasVirtualDigital) {
          active_item = "Paraxip.wizard.sip_form";
        } else {
          Ext.Msg.alert('No board', 'Please add a board to continue');
          active_item = "Paraxip.wizard.hardware_form";
          show_back = false;
        }
      } else {
        active_item = "Paraxip.wizard.hardware_form";
        show_back = false;
      }
      break;
    case "Paraxip.wizard.analog_form":
      if (hasDigital && hasPRI) {
        active_item = "Paraxip.wizard.isdn_form";
      } else {
        active_item = "Paraxip.wizard.audio_form";
      }
      break;
    case "Paraxip.wizard.isdn_form":
      active_item = "Paraxip.wizard.audio_form";
      break;
    case "Paraxip.wizard.audio_form":
    
      if( Paraxip.wizard.AgcMode.value == 'MANUAL' &&
          Paraxip.wizard.ManualGainIsValid == false )
      { 
        Ext.Msg.alert('Invalid manual gain value',
                    "Manual Gain must be within -24 dB and 24 dB");
        active_item = "Paraxip.wizard.audio_form";    
      }
      else if (Paraxip.wizard.AgcMode.value == 'AUTOMATIC' &&
               Paraxip.wizard.AutoLevelIsValid == false )
      { 
        Ext.Msg.alert('Invalid Target level value',
                    "Automatic target level must be within -40 dBm0 and 0 dBm0");
        active_item = "Paraxip.wizard.audio_form";    
      }      
      else
      {
        active_item = "Paraxip.wizard.sip_form";    
      }
      break;
    case "Paraxip.wizard.sip_form":
      // Change default transport combobox values according to listening ports
      // selected by the user
      if (!Paraxip.wizard.enableUdp.checked &&
          !Paraxip.wizard.enableTcp.checked &&
          !Paraxip.wizard.enableTls.checked) {
          Ext.Msg.alert('No transport',
                        'At least one listening address must be configured');
          active_item = "Paraxip.wizard.sip_form";
      } else {
        if( Paraxip.wizard.enableTls.checked ) {
          Paraxip.wizard.outTransportProtocol.setValue("tls");
          Paraxip.wizard.outTransportProtocol.store.loadData(["tls"]);

        } else {
          Paraxip.wizard.outTransportProtocol.store.loadData([]);

          var outTransport = "udp";
          if (Paraxip.wizard.outTransportProtocol.getValue() != "tls") {
            outTransport = Paraxip.wizard.outTransportProtocol.getValue();
          }

          if( Paraxip.wizard.enableUdp.checked ) {
            Paraxip.wizard.outTransportProtocol.setValue("udp");
            Paraxip.wizard.outTransportProtocol.store.loadData(["udp"]);
          }

          if( Paraxip.wizard.enableTcp.checked ) {
            if( Paraxip.wizard.enableUdp.checked ) {
              // Both are enabled, set it to the old value.
              Paraxip.wizard.outTransportProtocol.setValue(outTransport);
            } else {
              // Only TCP is enabled, set it to TCP
              Paraxip.wizard.outTransportProtocol.setValue("tcp");
            }
            // Add tcp to the store list
            Paraxip.wizard.outTransportProtocol.store.loadData(["tcp"],true);
          }
        }
        updateDefaultPort(Paraxip.wizard.sipOutPort);
        updateDefaultPort(Paraxip.wizard.failoverSipOutPort);
        active_item = "Paraxip.wizard.call_routing_form";
        if (isGatewayInCLI) {
          next_button.setVisible(false);
          save_button.setVisible(true);
        }
      }
      break;
    case "Paraxip.wizard.call_routing_form":
      if (!validateCallRoutingFields()) {
        active_item = "Paraxip.wizard.call_routing_form";
      } else {
        if (isGatewayInCLI) {
          active_item = "Paraxip.wizard.finish_form";
          next_button.setVisible(false);
          save_button.setVisible(false);
          fxotune_button.setVisible(true);
          fxotune_button.setDisabled(!hasFxoInterface);
          start_button.setVisible(true);
          start_button.disable();
          finish_button.setVisible(true);
          show_back = false;
        } else {
          active_item = "Paraxip.wizard.services_form";
          next_button.setVisible(false);
          save_button.setVisible(true);
        }

      }
      break;
    case "Paraxip.wizard.services_form":
    case "Paraxip.wizard.script_results":
      active_item = "Paraxip.wizard.finish_form";
      next_button.setVisible(false);
      save_button.setVisible(false);
      fxotune_button.setVisible(true);
      fxotune_button.setDisabled(!hasFxoInterface);
      start_button.setVisible(true);
      finish_button.setVisible(true);
      show_back = false;
      break;
    case "Paraxip.wizard.finish_form":
    default:
      next_button.setVisible(true);
      save_button.setVisible(false);
      fxotune_button.setVisible(false);
      start_button.setVisible(false);
      finish_button.setVisible(false);
      active_item = "Paraxip.wizard.front_form";
      show_back = false;
      break;
    }
  } else if (direction == "back") { //go backward
    switch (active_id) {
    case "Paraxip.wizard.hardware_form":
      if (!hardwareDetectionMode || validateRecords()) {
        active_item = "Paraxip.wizard.front_form";
        show_back = false;
      } else {
        active_item = "Paraxip.wizard.hardware_form";
        show_back = false;
      }
      break;
    case "Paraxip.wizard.analog_form":
      active_item = "Paraxip.wizard.hardware_form";
      show_back = false;
      break;
    case "Paraxip.wizard.isdn_form":
      active_item = "Paraxip.wizard.analog_form";
      break;
     case "Paraxip.wizard.audio_form":
      if (hasDigital && hasPRI) {
        active_item = "Paraxip.wizard.isdn_form";
      } else if( hasAnalog ) {
        active_item = "Paraxip.wizard.analog_form";
      } else {
        active_item = "Paraxip.wizard.hardware_form";
        show_back = false;
      }      
      break;
    case "Paraxip.wizard.sip_form":
      active_item = "Paraxip.wizard.audio_form";
      break;
    case "Paraxip.wizard.call_routing_form":
      if (!validateCallRoutingFields()) {
        active_item = "Paraxip.wizard.call_routing_form";
      } else {
        active_item = "Paraxip.wizard.sip_form";
        if (isGatewayInCLI) {
          next_button.setVisible(true);
          save_button.setVisible(false);
        }
      }
      break;
    case "Paraxip.wizard.services_form":
      {
        active_item = "Paraxip.wizard.call_routing_form";
        next_button.setVisible(true);
        save_button.setVisible(false);
        break;
      }
    default: // hardware form
      active_item = "Paraxip.wizard.front_form";
      show_back = false;
      break;
    }
  }

  if (active_item == "Paraxip.wizard.hardware_form" && hardwareDetectionMode) {
    help_button.setVisible(true);
  } else {
    help_button.setVisible(false);
  }

  if( active_item == "Paraxip.wizard.sip_form" &&
      primaryIPAddress.getValue() == "") {
    // Set the value of the combobox to the first IP address in the list.
    // At least one ip address will be there if the call succeeded since we
    // always add 127.0.0.1 at the end of the array.
    primaryIPAddress.setValue( ipAddressStore.getAt(0).data.ip );
  }

  lay.setActiveItem(active_item);
  lay.container.setTitle(lay.activeItem.title);

  back_button.setVisible(show_back);

};



var back_button = new Ext.Button({
  id        : 'move-prev'
  ,text     : '<- Back'
  ,hidden   : true
  ,minWidth : 80
});

back_button.on('click', navHandler.createDelegate(back_button, ['back']));

var next_button = new Ext.Button({
  id        : 'move-next'
  ,text     : 'Next ->'
  ,minWidth : 80
});

next_button.on('click', navHandler.createDelegate(next_button, ['next']));

var save_button = new Ext.Button({
  id        : 'save'
  ,text     : 'Save'
  ,hidden   : true
  ,minWidth : 80
});

save_button.on('click', saveHandler.createDelegate(save_button));

var finish_button = new Ext.Button({
  id        : 'finish'
  ,text     : 'Finish'
  ,hidden   : true
  ,minWidth : 105
});

finish_button.on('click', function() { finishHandler(false); });

var start_button = new Ext.Button({
  id        : 'start'
  ,text     : 'Restart Gateway'
  ,hidden   : true
  ,minWidth : 105
});

start_button.on('click', restartGatewayHandler.createDelegate(start_button,['yes']));

var help_button = new Ext.Button({
  id        : 'help'
  ,text     : 'Help'
  ,hidden   : true
  ,minWidth : 105
});

help_button.on('click', helpHandler.createDelegate(help_button));

var fxotune_button = new Ext.Button({
  id        : 'fxotune'
  ,text     : 'Calibrate FXO lines'
  ,hidden   : true
  ,minWidth : 105
});

fxotune_button.on('click', fxotuneHandler.createDelegate(fxotune_button));

var wizard = new Ext.FormPanel({
  title         : 'Wizard'
  ,id           : 'wizard'
  ,layout       : 'card'
  ,hideMode     : 'offsets'
  ,layoutConfig : { deferedRender: true, layoutOnTabChange: true }
  ,defaults     : { border: false }
  ,bbar         : [
    back_button,
    '->',
    oemTestLabel,
    '->',
    help_button,
    '',
    next_button,
    save_button,
    fxotune_button,
    '',
    start_button,
    '',
    finish_button,
    ''
  ]
});

var isRendered = false; //keep trace of the first render done by doLayout()

wizard.add(hardware_form);
wizard.add(isdn_form);
wizard.add(call_routing_form);




wizard.add(sip_form);

wizard.add(services_form);
wizard.add(analog_form);
wizard.add(audio_form);
wizard.add(front_form);
wizard.add(waiting_script);
wizard.add(script_results);
wizard.add(finish_form);

wizard.on('afterlayout', function() {
  if (!isRendered) {
    wizard.setTitle(front_form.title);
    isRendered = true;
  } else if (wizard.getLayout().activeItem === null) {
    wizard.getLayout().setActiveItem(front_form);
  }
});


